"
 COPYRIGHT (c) 1989 by Claus Gittinger / eXept Software AG
 COPYRIGHT (c) 2016 Jan Vrany
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libcomp' }"

"{ NameSpace: Smalltalk }"

DIEntry subclass:#DIInfo
	instanceVariableNames:'version sections_count sections'
	classVariableNames:''
	poolDictionaries:'DIInfoVersions'
	category:'System-Compiler-Debug Info'
!

!DIInfo class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1989 by Claus Gittinger / eXept Software AG
 COPYRIGHT (c) 2016 Jan Vrany
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!DIInfo class methodsFor:'instance creation'!

new
    "return an initialized instance"

    ^ self basicNew initialize.
! !

!DIInfo methodsFor:'accessing'!

dbgVariableTable
    ^ sections detect:[:e | e isVariableTableSection ] ifNone:[ nil ]

    "Created: / 15-07-2018 / 11:28:20 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!DIInfo methodsFor:'adding & removing'!

addSection: aDISection
    sections := sections copyWith: aDISection.
    sections_count := sections_count + 1.

    "Created: / 14-07-2018 / 20:45:57 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!DIInfo methodsFor:'initialization'!

initialize
    "Invoked when a new instance is created."


    version := DbgInfoVersion1.
    sections_count := 0.
    sections := #().

    "/ super initialize.   -- commented since inherited method does nothing

    "Modified: / 14-07-2018 / 20:47:28 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!DIInfo methodsFor:'reading & writing'!

decode: aStream
    size := aStream nextUnsignedInt16MSB: UninterpretedBytes isBigEndian.
    version := aStream nextByte.
    sections_count := aStream nextUnsignedInt16MSB: UninterpretedBytes isBigEndian.
    sections := (1 to: sections_count) collect: [ :i | DISection decode: aStream ].
    self assert: aStream position == size.

    "Created: / 10-07-2018 / 12:45:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

encode: aStream
    self encodePrepare: aStream.
    aStream nextPutByte: version.
    aStream nextPutInt16: sections_count MSB: UninterpretedBytes isBigEndian.        
    sections do:[:section | section encode: aStream ].
    self encodeFinish: aStream.

    "Created: / 15-07-2018 / 10:55:33 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

